#!/usr/bin/env python
# coding: utf-8

# In[6]:


import numpy as np
import random as rd
from matplotlib import pyplot as plt
from scipy import stats
plt.rcParams['axes.grid'] = True        
plt.rcParams['savefig.format'] = 'png'


# In[7]:


plt.figure(figsize=(20,10))

x = np.linspace(-2.5,2.5,5001)
y1 = np.full(5001,0)
y2 = np.full(5001,0)
for k in range (0,5):
    y1[500+k*1000]=1
plt.plot(x,y1,linestyle =':', label='Peigne de Dirac')

for k in range (0,5):
    for i in range (-150,150):
        y2[500+k*1000+i]=1
plt.plot(x,y2,linestyle ='-', label ='Profil réel, peigne convolué par $\Pi_b(x)$ ')

plt.xlabel('Position $\\frac{x}{a}$',fontsize=32)
plt.ylabel('Transparence t($\\frac{x}{a}$)',fontsize=32)
plt.xticks(fontsize=32)
plt.yticks(fontsize=32)
plt.title('Profil de transparence du réseau', fontsize=32)
plt.legend(fontsize=24)
plt.xlim(-2.5,2.5)
plt.ylim(-0.1,1.26)
plt.savefig('C:\\Users\\dupuy\\Desktop\\Transparence',bbox_inches='tight')

plt.show()


# In[11]:


plt.figure(figsize=(20,10))

a = 5*10**(-6)
b = 5*10**(-7)
N = 10
Lambda = 500*10**(-9)

x = np.linspace(-1,1,2001)
y1 = np.full(2001,0)
y2 = np.full(2001,0)
for k in range (0,2001):
    y1= (np.sinc(np.pi*b*x/Lambda))**2
    y2= (np.sin(N*np.pi*a*x/Lambda)/(np.sin(np.pi*a*x/Lambda)))**2
y2 = y2/y2[1001]
for k in range(0,21):
    y2[k*100]=1
Y = y1*y2         


plt.plot(x,y1,color = 'r',linestyle =':', label='Facteur de structure de la fente S(sin($\\theta$))')
plt.plot(x,y2,color = 'y',linestyle ='--', label='Facteur de forme du réseau F(sin($\\theta$))')
plt.plot(x,Y,color = 'b',linestyle ='-', label='Intensité totale I(sin($\\theta$)) = S(sin($\\theta$).F(sin($\\theta$))')


plt.xlabel('Sin($\\theta$)',fontsize=32)
plt.ylabel('Intensité normalisée',fontsize=32)
plt.xticks(fontsize=32)
plt.yticks(fontsize=32)
plt.title('Figure de diffraction', fontsize=32)
plt.legend(fontsize=24)
plt.xlim(-1,1)
plt.ylim(-0.05,1.35)
plt.savefig('C:\\Users\\dupuy\\Desktop\\Diffraction',bbox_inches='tight')

plt.show()

